Index: branches/HTM-8.2-dev0/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- branches/HTM-8.2-dev0/source/Lib/TLibCommon/TComPrediction.h	(revision 710)
+++ branches/HTM-8.2-dev0/source/Lib/TLibCommon/TComPrediction.h	(revision 711)
@@ -93,4 +93,7 @@
 #if H_3D_ARP
   Void xPredInterUniARP         ( TComDataCU* pcCU,                          UInt uiPartAddr,               Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi=false, TComMvField * pNewMvFiled = NULL );
+#if QC_MTK_INTERVIEW_ARP_F0123_F0108
+  Void xPredInterUniARPviewRef( TComDataCU* pcCU, UInt uiPartAddr, Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi, TComMvField * pNewMvFiled = NULL );
+#endif
 #endif
   Void xPredInterUni            ( TComDataCU* pcCU,                          UInt uiPartAddr,               Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi=false          );
@@ -120,7 +123,13 @@
 
 #if H_3D_VSP
+#if MTK_F0109_LG_F0120_VSP_BLOCK
+  Void xGetVirtualDepth           ( TComDataCU *cu, TComPicYuv *picRefDepth, TComMv *dv, UInt partAddr, Int width, Int height, TComYuv *yuvDepth, Int &vspSize, Int txtPerDepthX=1, Int txtPerDepthY=1 );
+  Void xPredInterLumaBlkFromDM    ( TComDataCU *cu, TComPicYuv *picRef, TComYuv *yuvDepth, Int* shiftLUT, TComMv *mv, UInt partAddr, Int width, Int height, Bool isDepth, TComYuv *&pcYuvDst, Bool isBi, Int vspSize);
+  Void xPredInterChromaBlkFromDM  ( TComDataCU *cu, TComPicYuv *picRef, TComYuv *yuvDepth, Int* shiftLUT, TComMv *mv, UInt partAddr, Int width, Int height, Bool isDepth, TComYuv *&pcYuvDst, Bool isBi, Int vspSize);
+#else
   Void xGetVirtualDepth           ( TComDataCU *cu, TComPicYuv *picRefDepth, TComMv *dv, UInt partAddr, Int width, Int height, TComYuv *yuvDepth, Int txtPerDepthX=1, Int txtPerDepthY=1 );
   Void xPredInterLumaBlkFromDM    ( TComDataCU *cu, TComPicYuv *picRef, TComYuv *yuvDepth, Int* shiftLUT, TComMv *mv, UInt partAddr, Int width, Int height, Bool isDepth, TComYuv *&pcYuvDst, Bool isBi );
   Void xPredInterChromaBlkFromDM  ( TComDataCU *cu, TComPicYuv *picRef, TComYuv *yuvDepth, Int* shiftLUT, TComMv *mv, UInt partAddr, Int width, Int height, Bool isDepth, TComYuv *&pcYuvDst, Bool isBi );
+#endif
 #endif
 
Index: branches/HTM-8.2-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-8.2-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 710)
+++ branches/HTM-8.2-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 711)
@@ -132,5 +132,5 @@
                                               // TEXTURE MERGING CANDIDATE     , JCT3V-C0137
                                               // QC_INRIA_MTK_MRG_E0126 
-#define SEC_MPI_ENABLING_MERGE_F0150      1   // MPI flag in VPS and enabling in Merge mode
+
 
 #define H_3D_TMVP                         1   // QC_TMVP_C0047 
@@ -175,8 +175,4 @@
 #endif
 
-#define ETRIKHU_MERGE_REUSE_F0093         1   // Reuse HEVC merge candidate list construction for base candidates, JCT3V-F0093 
-
-
-
 // Rate Control
 #define KWU_FIX_URQ                       1
@@ -212,13 +208,4 @@
 #if H_3D_ARP
 #define H_3D_ARP_WFNR                     3
-#define QC_MTK_INTERVIEW_ARP_F0123_F0108  1 //JCT3V-F0123; JCT3V-F0108
-#define QC_MTK_INTERVIEW_ARP_F0123_F0108  1 //JCT3V-F0123; JCT3V-F0108
-#define SHARP_ARP_REF_CHECK_F0105         1 // ARP reference picture selection and DPB check
-#define LGE_ARP_CTX_F0161 1 //JCT3V-F0161
-#endif
-
-///// ***** Inter-view motion merge candidate *********
-#if H_3D_IV_MERGE
-#define QC_DEPTH_IV_MRG_F0125             1   // JCT3V-F0125: Depth oriented Inter-view MV candidate
 #endif
 
@@ -235,6 +222,4 @@
 ///// ***** VIEW SYNTHESIS PREDICTION *********
 #if H_3D_VSP
-#define MTK_F0109_LG_F0120_VSP_BLOCK      1   // MTK_LG_SIMPLIFY_VSP_BLOCK_PARTITION_F0109_F0120  
-#define SHARP_VSP_BLOCK_IN_AMP_F0102      1   // VSP partitioning for AMP
 #define H_3D_VSP_BLOCKSIZE                4   // Supported values: 1, 2, and 4
 #if H_3D_VSP_BLOCKSIZE == 1
@@ -243,6 +228,4 @@
 #define H_3D_VSP_CONSTRAINED              0
 #endif
-#define MTK_VSP_SIMPLIFICATION_F0111      1   // 1. Inherited VSP also use NBDV of current CU, 2. VSP cannot be inherited from above LCU rowss
-#define LGE_SHARP_VSP_INHERIT_F0104       1
 #endif
 
@@ -260,4 +243,35 @@
 #define H_3D_FCO_VSP_DONBDV_E0163               0   // Adaptive depth reference for flexible coding order
 #endif
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+///////////////////////////////////   HTM-9.0 Integrations //////////////////////////////
+/////////////////////////////////////////////////////////////////////////////////////////
+
+#if H_3D
+
+#define FIX_MISSING_MACRO_R690                  1   // Missing macro in integration to revision 690
+
+#define SEC_MPI_ENABLING_MERGE_F0150            1   // MPI flag in VPS and enabling in Merge mode
+#define ETRIKHU_MERGE_REUSE_F0093               1   // Reuse HEVC merge candidate list construction for base candidates, JCT3V-F0093 
+
+#if H_3D_ARP
+#define QC_MTK_INTERVIEW_ARP_F0123_F0108        1   //JCT3V-F0123; JCT3V-F0108
+#define SHARP_ARP_REF_CHECK_F0105               1   // ARP reference picture selection and DPB check
+#define LGE_ARP_CTX_F0161                       1   //JCT3V-F0161
+#endif
+
+#if H_3D_IV_MERGE
+#define QC_DEPTH_IV_MRG_F0125                   1   // JCT3V-F0125: Depth oriented Inter-view MV candidate
+#endif
+
+#if H_3D_VSP
+#define MTK_F0109_LG_F0120_VSP_BLOCK            1   // MTK_LG_SIMPLIFY_VSP_BLOCK_PARTITION_F0109_F0120  
+#define SHARP_VSP_BLOCK_IN_AMP_F0102            1   // VSP partitioning for AMP
+#define MTK_VSP_SIMPLIFICATION_F0111            1   // 1. Inherited VSP also use NBDV of current CU, 2. VSP cannot be inherited from above LCU rowss
+#define LGE_SHARP_VSP_INHERIT_F0104             1
+#endif
+#endif
+
 
 /////////////////////////////////////////////////////////////////////////////////////////