Index: branches/HTM-8.2-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-8.2-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 712)
+++ branches/HTM-8.2-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 713)
@@ -65,5 +65,5 @@
 #define H_3D          ( HEVC_EXT == 2)
 
-#define LGE_BUGFIX_F0158 1 //JCT3V-F0158
+
 /////////////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////   MAJOR DEFINES   ///////////////////////////////////  
@@ -104,7 +104,4 @@
                                               // MTK_CLIPPING_ALIGN_IC_E0168       // To support simplify bi-prediction PU with identical motion checking, JCT3V-E0168
 
-#define LGE_IC_CTX_F0160 1 //JCT3V-F0160
-#define SEC_ONLY_TEXTURE_IC_F0151         1
-
 #if H_3D_NBDV
 #define H_3D_NBDV_REF                     1   // Depth oriented neighboring block disparity derivation
@@ -162,10 +159,8 @@
                                               // LGE_SDC_REMOVE_DC_E0158 Removal of DC mode from SDC
                                               // LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX 1   Removal of overlap between DMM3 and DMM1
-#define SEC_DMM3_RBC_F0147                1   // Removal of DMM3 and RBC from DMMs
 
 #define H_3D_INTER_SDC                    1   // INTER SDC, Inter simplified depth coding
                                               // LGE_INTER_SDC_E0156  Enable inter SDC for depth coding
 #define H_3D_FCO                          0   // Flexible coding order for 3D
-
 
 
@@ -218,7 +213,4 @@
 #if H_3D_DIM
 #define H_3D_DIM_DMM                      1   // Depth Modeling Modes
-#if !SEC_DMM3_RBC_F0147
-#define H_3D_DIM_RBC                      1   // Region Boundary Chain mode
-#endif
 #define H_3D_DIM_SDC                      1   // Simplified Depth Coding method
 #define H_3D_DIM_DLT                      1   // Depth Lookup Table
@@ -226,7 +218,4 @@
                                               // HHI_DEPTH_INTRA_SEARCH_RAU_C0160
                                               // LG_ZEROINTRADEPTHRESI_A0087
-#define QC_DIM_DELTADC_UNIFY_F0132        1   // Unify delta DC coding in depth intra modes
-#define HHI_DIM_PREDSAMP_FIX_F0171        1
-#define LGE_PRED_RES_CODING_DLT_DOMAIN_F0159 1 //JCT3V-F0159
 #endif
 ///// ***** VIEW SYNTHESIS PREDICTION *********
@@ -260,25 +249,38 @@
 
 #if H_3D
-
-#define FIX_MISSING_MACRO_R690                  1   // Missing macro in integration to revision 690
-
-#define SEC_MPI_ENABLING_MERGE_F0150            1   // MPI flag in VPS and enabling in Merge mode
-#define ETRIKHU_MERGE_REUSE_F0093               1   // Reuse HEVC merge candidate list construction for base candidates, JCT3V-F0093 
+#define FIX_MISSING_MACRO_R690                  1 // Missing macro in integration to revision 690
+
+#define SEC_MPI_ENABLING_MERGE_F0150            1 // MPI flag in VPS and enabling in Merge mode
+#define ETRIKHU_MERGE_REUSE_F0093               1 // Reuse HEVC merge candidate list construction for base candidates, JCT3V-F0093 
 
 #if H_3D_ARP
-#define QC_MTK_INTERVIEW_ARP_F0123_F0108        1   //JCT3V-F0123; JCT3V-F0108
-#define SHARP_ARP_REF_CHECK_F0105               1   // ARP reference picture selection and DPB check
-#define LGE_ARP_CTX_F0161                       1   //JCT3V-F0161
+#define QC_MTK_INTERVIEW_ARP_F0123_F0108        1 //JCT3V-F0123; JCT3V-F0108
+#define SHARP_ARP_REF_CHECK_F0105               1 // ARP reference picture selection and DPB check
+#define LGE_ARP_CTX_F0161                       1 //JCT3V-F0161
 #endif
 
 #if H_3D_IV_MERGE
-#define QC_DEPTH_IV_MRG_F0125                   1   // JCT3V-F0125: Depth oriented Inter-view MV candidate
+#define QC_DEPTH_IV_MRG_F0125                   1 // JCT3V-F0125: Depth oriented Inter-view MV candidate
 #endif
 
 #if H_3D_VSP
-#define MTK_F0109_LG_F0120_VSP_BLOCK            1   // MTK_LG_SIMPLIFY_VSP_BLOCK_PARTITION_F0109_F0120  
-#define SHARP_VSP_BLOCK_IN_AMP_F0102            1   // VSP partitioning for AMP
-#define MTK_VSP_SIMPLIFICATION_F0111            1   // 1. Inherited VSP also use NBDV of current CU, 2. VSP cannot be inherited from above LCU rowss
+#define MTK_F0109_LG_F0120_VSP_BLOCK            1 // MTK_LG_SIMPLIFY_VSP_BLOCK_PARTITION_F0109_F0120  
+#define SHARP_VSP_BLOCK_IN_AMP_F0102            1 // VSP partitioning for AMP
+#define MTK_VSP_SIMPLIFICATION_F0111            1 // 1. Inherited VSP also use NBDV of current CU, 2. VSP cannot be inherited from above LCU rowss
 #define LGE_SHARP_VSP_INHERIT_F0104             1
+#endif
+
+#define LGE_BUGFIX_F0158                        1 //JCT3V-F0158
+#define LGE_IC_CTX_F0160                        1 //JCT3V-F0160
+#define SEC_ONLY_TEXTURE_IC_F0151               1
+
+#if H_3D_DIM
+#define SEC_DMM3_RBC_F0147                      1 // Removal of DMM3 and RBC from DMMs
+#if !SEC_DMM3_RBC_F0147
+#define H_3D_DIM_RBC                            1 // Region Boundary Chain mode
+#endif
+#define QC_DIM_DELTADC_UNIFY_F0132              1 // Unify delta DC coding in depth intra modes
+#define HHI_DIM_PREDSAMP_FIX_F0171              1
+#define LGE_PRED_RES_CODING_DLT_DOMAIN_F0159    1 //JCT3V-F0159
 #endif
 #endif