Index: trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_2view+depth_AllIntra.cfg
===================================================================
--- trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_2view+depth_AllIntra.cfg	(revision 725)
+++ trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_2view+depth_AllIntra.cfg	(revision 735)
@@ -20,10 +20,31 @@
 
 #======== VPS ============================
-ScalabilityMask               : 3           # Scalability Mask             ( 1: View Scalability, 3: View + Depth Scalability )
-DimensionIdLen                : 2 1         # Number of bits to store Ids,  per scalability dimension, (m)
-ViewId                        : 1 1 0 0     # ViewId     (m) 
+ScalabilityMask               : 3           # Scalability Mask             ( 2: View Scalability, 3: View + Depth Scalability )
+DimensionIdLen                : 1 2         # Number of bits to store Ids,  per scalability dimension, (m)
+ViewOrderIndex                : 0 0 1 1     # ViewOrderIndex (m)
 DepthFlag                     : 0 1 0 1     # DepthFlag  (m) 
 LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling ) (m)
 SplittingFlag                 : 0           # Splitting Flag 
+ViewId                        : 1 0         # ViewId per ViewOrderIndex (m)
+
+#======== VPS/ Layer sets ================
+VpsNumLayerSets               : 3           # Number of layer sets    
+LayerIdsInSet_0               : 0           # LayerIds in vps of layer set
+LayerIdsInSet_1               : 0 1         # LayerIds in vps of layer set
+LayerIdsInSet_2               : 0 1 2 3     # LayerIds in vps of layer set
+
+DefaultOneTargetOutputLayerFlag: 0          # Output highest layer of layer sets by default
+OutputLayerSetIdx             : 2           # Indices of layer sets used as additional output layer sets
+LayerIdsInAddOutputLayerSet_0 : 2 3         # LayerIds in vps of additional output layers
+ProfileLevelTierIdx           : 0 0 0 0     # Indices to profile level tier (TBD)
+
+#======== VPS / Dependencies ================
+DirectRefLayers_1             :             # LayerIds in vps of direct reference layers 
+DirectRefLayers_2             : 0           # LayerIds in vps of direct reference layers 
+DirectRefLayers_3             : 1           # LayerIds in vps of direct reference layers 
+
+DependencyTypes_1             :             # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_2             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_3             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
 
 #========== Camera parameters ==========
@@ -140,4 +161,11 @@
 
 #========== multiview coding tools ==========
+IvMvPred                            : 1 1              # Inter-view motion prediction
+AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on )  (v/d)
+ViewSynthesisPred                   : 1                # View synthesis prediction 
+DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
+IvMvScaling                         : 1                # Interview motion vector scaling
+SubPULog2Size                       : 3				   # Log2 of sub-PU size for IvMvPred (2...6)
 
 
@@ -149,4 +177,6 @@
 QTL                                : 1
 PC                                 : 1
+InterSDC                           : 1                             # use of inter sdc
+MPI                                : 1
 
 #========== view synthesis optimization (VSO) ==========
Index: trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_3view+depth_AllIntra.cfg
===================================================================
--- trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_3view+depth_AllIntra.cfg	(revision 725)
+++ trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_3view+depth_AllIntra.cfg	(revision 735)
@@ -24,10 +24,38 @@
 
 #======== VPS ============================
-ScalabilityMask               : 3           # Scalability Mask             ( 1: View Scalability, 3: View + Depth Scalability )
-DimensionIdLen                : 2 1         # Number of bits to store Ids,  per scalability dimension, (m)
-ViewId                        : 1 1 0 0 2 2 # ViewId     (m) 
+ScalabilityMask               : 3           # Scalability Mask             ( 2: View Scalability, 3: View + Depth Scalability )
+DimensionIdLen                : 1 2         # Number of bits to store Ids,  per scalability dimension, (m)
+ViewOrderIndex                : 0 0 1 1 2 2 # ViewOrderIndex (m)
 DepthFlag                     : 0 1 0 1 0 1 # DepthFlag  (m) 
 LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling ) (m)
 SplittingFlag                 : 0           # Splitting Flag 
+ViewId                        : 1 0 2       # ViewId per ViewOrderIndex (m)
+
+#======== VPS/ Layer sets ================
+VpsNumLayerSets               : 5           # Number of layer sets    
+LayerIdsInSet_0               : 0           # LayerIds in vps of layer set
+LayerIdsInSet_1               : 0 1         # LayerIds in vps of layer set
+LayerIdsInSet_2               : 0 1 2 3     # LayerIds in vps of layer set
+LayerIdsInSet_3               : 0 1 4 5     # LayerIds in vps of layer set
+LayerIdsInSet_4               : 0 1 2 3 4 5 # LayerIds in vps of layer set
+
+DefaultOneTargetOutputLayerFlag: 0           # Output highest layer of layer sets by default
+OutputLayerSetIdx             : 2 3          # Indices of layer sets used as additional output layer sets
+LayerIdsInAddOutputLayerSet_0 : 2 3          # LayerIds of additional output layers
+LayerIdsInAddOutputLayerSet_1 : 4 5          # LayerIds of additional output layers
+ProfileLevelTierIdx           : 0 0 0 0 0 0 0 0 # Indices to profile level tier (TBD)
+
+#======== VPS / Dependencies ================
+DirectRefLayers_1             :             # LayerIds in vps of direct reference layers 
+DirectRefLayers_2             : 0           # LayerIds in vps of direct reference layers 
+DirectRefLayers_3             : 1           # LayerIds in vps of direct reference layers 
+DirectRefLayers_4             : 0           # LayerIds in vps of direct reference layers 
+DirectRefLayers_5             : 1           # LayerIds in vps of direct reference layers 
+
+DependencyTypes_1             :             # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_2             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_3             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_4             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_5             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
 
 #========== Camera parameters ==========
@@ -50,4 +78,5 @@
 DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CDR, 2:IDR
 GOPSize                       : 1           # GOP Size (number of B slice = GOPSize-1)
+
 Frame1    : B  1  1  0.442   0  0  0  4  0                  0                    0
 FrameI_l1:  I  0  0  0.442   0  0  0  0  0                  0                    0             
@@ -147,4 +176,11 @@
 
 #========== multiview coding tools ==========
+IvMvPred                            : 1 1              # Inter-view motion prediction
+AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on )  (v/d)
+ViewSynthesisPred                   : 1                # View synthesis prediction 
+DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
+IvMvScaling                         : 1                # Interview motion vector scaling
+SubPULog2Size                       : 3				   # Log2 of sub-PU size for IvMvPred (2...6)
 
 
@@ -156,4 +192,6 @@
 QTL                                : 1
 PC                                 : 1
+InterSDC                           : 1                             # use of inter sdc
+MPI                                : 1
 
 #========== view synthesis optimization (VSO) ==========
Index: trunk/cfg/3D-HEVC/baseCfg_2view+depth.cfg
===================================================================
--- trunk/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 725)
+++ trunk/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 735)
@@ -201,4 +201,6 @@
 DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
 IvMvScaling                         : 1                # Interview motion vector scaling
+SubPULog2Size                       : 3                # Log2 of sub-PU size for IvMvPred (2...6)
+
 
 #========== depth coding tools ==========
Index: trunk/cfg/3D-HEVC/fullCfg.cfg
===================================================================
--- trunk/cfg/3D-HEVC/fullCfg.cfg	(revision 725)
+++ trunk/cfg/3D-HEVC/fullCfg.cfg	(revision 735)
@@ -235,12 +235,4 @@
 
 #============ Rate Control URQ ======================
-<<<<<<< .mine
-#RateCtrl                         : 0                # 0: Disable rate control 1: Enable rate control with total target
-#DepthMADPred			    : 0		       # 0: Disable Depth based MAD prediction for extended view 1: Enable Depth based MAD prediction for extended view
-#TargetBitAssign  		    : 0			# Manual assignment of target bit-rate
-#ViewWiseTargetBits		    : 952 315 360 	# View-wise target bit-rate setting
-#TargetBitrate                       : 1500             # input target bitrate when RateCtrl is enable
-#NumLCUInUnit                        : 1                # Number of LCU in an Unit. Fraction is not allowed
-=======
 #RateCtrl                           : 0                # 0: Disable rate control 1: Enable rate control with total target
 #DepthMADPred                       : 0                # 0: Disable Depth based MAD prediction for extended view 1: Enable Depth based MAD prediction for extended view
@@ -249,8 +241,6 @@
 #TargetBitrate                      : 1500             # input target bitrate when RateCtrl is enable
 #NumLCUInUnit                       : 1                # Number of LCU in an Unit. Fraction is not allowed
->>>>>>> .r636
-
 #========== multiview coding tools ==========
-IvMvPred                            : 1                # Inter-view motion prediction
+IvMvPred                            : 1 1              # Inter-view motion prediction
 AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
 IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on ) (v/d)